%define pkg kdelibs
%define is_release 1
%define is_preview 1
%define VER 2.0
%define DATE 20001016
Summary: K Desktop Environment - Libraries
%if %{is_release}
Version: %{VER}
Source: ftp://ftp.kde.org/pub/kde/stable/%{version}/distribution/tar/generic/source/%{pkg}-%{version}.tar.bz2
%else
Version: %{VER}.%{DATE}
Source: cvs://cvs.kde.org/%{pkg}-%{DATE}.tar.bz2
%endif
Patch: kdelibs-1.94-glibc22.patch
Patch1: kdelibs-2.0-final.patch
%if %{is_preview}
Name: %{pkg}2
Prefix: /usr/lib/kde2
Requires: qt >= 2.2.0, kdesupport2
BuildRequires: qt-devel >= 2.2.0, kdesupport2-devel >= %{version}, kdoc
%else
Name: %{pkg}
Prefix: %{_prefix}
Requires: qt >= 2.2.0, kdesupport
BuildRequires: qt-devel >= 2.2.0, kdesupport-devel >= %{version}, kdoc
%endif
BuildPrereq: flex >= 2.5.4a-13
Icon: kde-icon.xpm
Epoch: 6
Release: 1
Group: System Environment/Libraries
License: LGPL
BuildRoot: %{_tmppath}/%{pkg}-buildroot

%description
Libraries for the K Desktop Environment:
KDE Libraries included: kdecore (KDE core library), kdeui (user interface),
kfm (file manager), khtmlw (HTML widget), kfile (file access), kspell
(spelling checker), jscript (javascript), kab (addressbook), kimgio (image
manipulation), arts (sound, mixing and animation).

%package devel
Group: Development/Libraries
Summary: Header files and documentation for compiling KDE applications.
%if %{is_preview}
Requires: qt-devel >= 2.2.1, %{name} = %{version}, kdesupport2-devel >= %{version}
%else
Requires: qt-devel >= 2.2.1, %{name} = %{version}, kdesupport-devel >= %{version}
%endif

%description devel
This package includes the header files you will need to compile
applications for KDE.  Also included is the KDE API documentation in HTML
format for easy browsing.

%package sound
Group: System Environment/Libraries
Summary: K Desktop Environment - Libraries for sound support
Requires: %{name} = %{version}

%description sound
Libraries for sound support in the K Desktop Environment:
arts and libkmid.

%package sound-devel
Group: Development/Libraries
Summary: Header files and documentation for compiling KDE applications with sound
Requires: %{name}-sound = %{version}, %{name} = %{version}, %{name}-devel = %{version}

%description sound-devel
This package includes the header files you will need to compile applications
using the KDE sound libraries, arts and libkmid.
Also included is the API documentation for these libraries, in HTML format for
easy browsing.

%prep
rm -rf $RPM_BUILD_ROOT

%if %{is_release}
%setup -q -n %{pkg}-%{version}
%else
#%setup -q -n %{pkg}
%endif
%patch -p1 -b .glibc22
%patch1 -p1 -b .final
make -f Makefile.cvs

# Fix some broken autogenerated files
cd arts/mcopidl
flex -oscanner.cc scanner.ll
cd ../../dcop/dcopidl
flex -oscanner.cc scanner.ll
cd ../..

%build
unset QTDIR || : ; . /etc/profile.d/qt.sh
if [ -x /usr/bin/getconf ]; then
  CPUS=`getconf _NPROCESSORS_ONLN`
fi
if test "x$CPUS" = "x" -o "x$CPUS" = "x0"; then
  CPUS=1
fi

export FLAGS="$RPM_OPT_FLAGS -DNDEBUG"

VERSION=`cat /etc/redhat-release |awk '{ print $5; }'`
%if %{is_preview}
CXXFLAGS="$FLAGS" CFLAGS="$FLAGS" ./configure \
	--prefix=%{prefix} \
	--disable-final \
	--enable-libshm \
	--with-distribution="Red Hat Linux $VERSION (preview)"
%else
CXXFLAGS="$FLAGS" CFLAGS="$FLAGS" ./configure \
	--prefix=%{prefix} \
	--enable-libshm \
	--includedir=%{prefix}/include/kde \
	--enable-final \
	--with-distribution="Red Hat Linux $VERSION"
%endif

make CFLAGS="$FLAGS" CXXFLAGS="$FLAGS" || make

%install
export DESTDIR=$RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install-strip

chmod a+x $RPM_BUILD_ROOT%{prefix}/lib/*

# Generate documentation
export PATH=%{prefix}/bin:$PATH
makekdedoc=`which makekdedoc`
if [ ! -z "$makekdedoc" ]; then
  kdocdir=$RPM_BUILD_ROOT%{_docdir}/%{pkg}-devel-%{version}-%{release} #used to be %{prefix}/share/kdedoc/ - but I think this makes more sense.
  mkdir -p $kdocdir
  qt2kdoc=`which qt2kdoc`
  if [ ! -z "$qt2kdoc" ]; then
    $qt2kdoc -o $kdocdir %{_docdir}/qt-devel-*/html || :
  fi
  $makekdedoc --rule-file=kdoc.rules --outputdir=$kdocdir || :
fi

LIBDOCS=$RPM_BUILD_ROOT%{_docdir}/%{name}-devel-%{version}-%{release}
SNDDOCS=$RPM_BUILD_ROOT%{_docdir}/%{name}-sound-devel-%{version}-%{release}
mkdir -p $SNDDOCS
[ -d $LIBDOCS/libkmid ] && mv $LIBDOCS/libkmid $SNDDOCS

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun
/sbin/ldconfig

%files
%defattr(-,root,root)
%{prefix}/bin/dcop*
%{prefix}/bin/kbuildsycoca
%{prefix}/bin/kcookiejar
%{prefix}/bin/kdb2html
%{prefix}/bin/kde*
%{prefix}/bin/kio*
%{prefix}/bin/klauncher
%{prefix}/bin/kmailservice
%{prefix}/bin/lnusertemp
%{prefix}/bin/settheme
%{prefix}/lib/*style.*
%{prefix}/lib/dcop*
%{prefix}/lib/kbuildsycoca*
%{prefix}/lib/kcookiejar*
%{prefix}/lib/kded*
%{prefix}/lib/kimg*
%{prefix}/lib/kio*
%{prefix}/lib/kjs*
%{prefix}/lib/klauncher*
%{prefix}/lib/kstephighcolor.*
%{prefix}/lib/libDCOP*
%{prefix}/lib/libkab.*
%{prefix}/lib/libkde*
%{prefix}/lib/libkfile.*
%{prefix}/lib/libkhtml.*
%{prefix}/lib/libkio.*
%{prefix}/lib/libkjava.*
%{prefix}/lib/libkjs.*
%{prefix}/lib/libkparts.*
%{prefix}/lib/libkspell.*
%{prefix}/lib/libkssl.*
%{prefix}/lib/libksycoca.*
%{prefix}/lib/libktexteditor.*
%dir %{prefix}/share/apps
%{prefix}/share/apps/*
%dir %{prefix}/share/config
%{prefix}/share/config/*
%{prefix}/share/icons/*
%dir %{prefix}/share/mimelnk
%{prefix}/share/mimelnk/*
%dir %{prefix}/share/services
%{prefix}/share/services/*
%dir %{prefix}/share/servicetypes
%{prefix}/share/servicetypes/*

%files devel
%defattr(-,root,root)
%if %{is_preview}
%{prefix}/include/*.h
%dir %{prefix}/include/dom
%{prefix}/include/dom/*
%dir %{prefix}/include/kio
%{prefix}/include/kio/*
%dir %{prefix}/include/kjs
%{prefix}/include/kjs/*
%dir %{prefix}/include/kdesu
%{prefix}/include/kdesu/*
%dir %{prefix}/include/kparts
%{prefix}/include/kparts/*
%else
%{prefix}/include/kde/*.h
%dir %{prefix}/include/kde/dom
%{prefix}/include/kde/dom/*
%dir %{prefix}/include/kde/kio
%{prefix}/include/kde/kio/*
%dir %{prefix}/include/kde/kjs
%{prefix}/include/kde/kjs/*
%dir %{prefix}/include/kde/kdesu
%{prefix}/include/kde/kdesu/*
%dir %{prefix}/include/kde/kparts
%{prefix}/include/kde/kparts/*
%endif
%docdir %{_docdir}/%{name}-devel-%{version}-%{release}

%files sound
%defattr(-,root,root)
%dir %{prefix}/lib/Arts
%{prefix}/lib/Arts/*
%{prefix}/bin/arts*
%{prefix}/bin/knotify
%{prefix}/lib/libarts*
%{prefix}/lib/libkmedia*
%{prefix}/lib/libkmid.*
%{prefix}/lib/lib*mcop.*
%{prefix}/lib/libsound*
%{prefix}/lib/knotify*
%{prefix}/lib/libx11globalcomm.*

%files sound-devel
%defattr(-,root,root)
%{prefix}/bin/mcopidl
%if %{is_preview}
%dir %{prefix}/include/arts
%{prefix}/include/arts/*
%dir %{prefix}/include/artsc
%{prefix}/include/artsc/*
%dir %{prefix}/include/libkmid
%{prefix}/include/libkmid/*
%else
%dir %{prefix}/include/kde/arts
%{prefix}/include/kde/arts/*
%dir %{prefix}/include/kde/artsc
%{prefix}/include/kde/artsc/*
%dir %{prefix}/include/kde/libkmid
%{prefix}/include/kde/libkmid/*
%endif
%docdir %{_docdir}/%{name}-sound-devel-%{version}-%{release}

%changelog
* Thu Oct 19 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- work around compiler problems on alpha

* Mon Oct 16 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0 final

* Sun Oct  1 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild

* Sat Sep 30 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new CVS snapshot
- fix up specfile
- exclude alpha for now (compiler bugs)

* Sat Sep 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- major specfile cleanups
- update CVS

* Fri Sep 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Move back to /usr
- New CVS snapshot
- Clean up specfile
- Use %%defines so we can build CVS snapshots and releases from the same
  specfile

* Fri Aug 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild with optimizations re-enabled (Qt works around the problem now)

* Thu Aug 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild with new Qt

* Tue Aug 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.93

* Sat Aug 05 2000 Than Ngo <than@redhat.de>
- don't use -DNDEBUG and -O2 on alpha,sparc to build, it breaks with Internal
  error (c++ bug)

* Fri Aug  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- update to current (I fixed the libGL detection issue there)

* Wed Aug  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- move to /usr/lib/kde2
- new snapshot

* Wed Jul 26 2000 Than Ngo <than@redhat.de>
- new snapshot

* Tue Jul 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot

* Thu Jul 20 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot, new Qt
- various fixes to spec file
- get rid of -O0, no longer required with gcc 2.96-41 (except on alpha)

* Tue Jul 18 2000 Than Ngo <than@redhat.de>
- rebuilt with gcc-2.96-40

* Sun Jul 16 2000 Than Ngo <than@redhat.de>
- use gcc 2.96
- new snapshot
- use -O0 for now (ICE)

* Sun Jul  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Use egcs++
- Epoch 3
- Update to current

* Fri Jun 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to current - segfaulting at initialization time is not a nice
  feature.

* Tue Jun 20 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- disable build on ia64 for now (compiler bugs)
- FHSify

* Thu Mar 30 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- split: move sound support to a separate package, suggestion from
  David Faure <david@linux-mandrake.com>

* Sat Mar 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- move it to /usr, where it belongs

* Wed Jan 05 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- move programming docs to %{prefix}/doc/kdelibs-devel-%{version}-%{release}
  and to kdelibs-devel package
- new snapshot

* Tue Dec 14 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Add qt version number in Requires, add kdoc HTML help
  (patch from David Faure <david@mandrakesoft.com>)
- Actually use the %clean section

* Mon Nov  1 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- almost completely rewrite spec file - move to DESTDIR system
- current snapshot

* Thu Oct 15 1999 Bernhard Rosenkraenzer <bero@redhat.de>
- 2.0 snapshots
- Change prefix to respect %{prefix} so we can coexist with KDE 1.x
- kdelibs-devel requires kdelibs

* Thu Sep 23 1999 Preston Brown <pbrown@redhat.com>
- move kde_htmldir to /usr/doc/kde
- mark doc files as such

* Tue Sep 21 1999 Preston Brown <pbrown@redhat.com>
- fix up perl include path for kdoc

* Thu Sep 16 1999 Preston Brown <pbrown@redhat.com>
- remove linking to qimgio from kdecore, moved to kpanel/kfm directly
- renamed "lowcolor" directory to "locolor"

* Mon Sep 13 1999 Preston Brown <pbrown@redhat.com>
- added lowcolor icons directory and /usr/share/pixmaps to icon search path
- hacking to recognize .desktop files as application/x-kdelnk

* Thu Sep 09 1999 Preston Brown <pbrown@redhat.com>
- added kdoc index files.

* Wed Sep 08 1999 Preston Brown <pbrown@redhat.com>
- updated to KDE 1.1.2.
- use /usr/lib/qt-1.44 as qt root.
- separate devel subpackages; include documentation and kdoc.
- added KDE icon.
- relocated includes to /usr/include/kde

* Fri Jun 11 1999 Preston Brown <pbrown@redhat.com>
- snapshot, includes kde 1.1.1 + fixes

* Mon Apr 19 1999 Preston Brown <pbrown@redhat.com>
- last snapshot before release

* Mon Apr 12 1999 Preston Brown <pbrown@redhat.com>
- latest stable snapshot

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Mon Feb 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to KDE 1.1 final.

* Fri Jan 15 1999 Preston Brown <pbrown@redhat.com>
- updated macros for RPM 3.0, removed redhat-release dependency

* Tue Jan 05 1999 Preston Brown <pbrown@redhat.com>
- re-integrated changes from Duncan Haldane
